# Contributing guidelines
First of all, thank you for taking the time to improve this program!

<details>
  <summary><h2>Changes to the main program</h2></summary>
  <ul>
    <li>Run `cargo fmt` on your commits, or at least on the PRs</li>
    <li>Check that your version of the program runs before creating the PR please!</li>
    <li>Code reductions, optimizations and simplifications are very much welcome</li>
  <ul>
</details>


<details>
  <summary><h2>Changes to the default config</h2></summary>
  <ul>
    <li>If the number of stations becomes high enough, I might start 
    filtering out some of them (like one per language, or one for each type of music).</li>
    <li>Also bear in mind that any change to the config will only affect new users 
    and people who deleted their configs.</li>
    <li>For this reason, take into account that the default config should remain simple, 
    more like a template/example than anything.</li>
    <li>The default maximum number of lines shown without scrolling is 7, so
    I'd set a maximum of 7 example stations unless there's a good reason.</li>
  </ul>
</details>


## The usual stuff
- Please, respect the [code of conduct](https://github.com/margual56/radio-cli/blob/main/CODE_OF_CONDUCT.md)
- Be patient with my response times to issues and PRs
- Have fun!
